diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-admin/includes/template.php ./wordpress-3.3/wp-admin/includes/template.php
*** ./wordpress-3.2.1/wp-admin/includes/template.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-admin/includes/template.php	2011-12-08 15:55:39.000000000 -0600
***************
*** 1689,1998 ****
  }
  
  /**
-  * Convert a screen string to a screen object
-  *
-  * @since 3.0.0
-  *
-  * @param string $screen The name of the screen
-  * @return object An object containing the safe screen name and id
-  */
- function convert_to_screen( $screen ) {
- 	$screen = str_replace( array('.php', '-new', '-add', '-network', '-user' ), '', $screen);
- 
- 	if ( is_network_admin() )
- 		$screen .= '-network';
- 	elseif ( is_user_admin() )
- 		$screen .= '-user';
- 
- 	$screen = (string) apply_filters( 'screen_meta_screen', $screen );
- 	$screen = (object) array('id' => $screen, 'base' => $screen);
- 	return $screen;
- }
- 
- function screen_meta($screen) {
- 	global $wp_meta_boxes, $_wp_contextual_help, $wp_list_table, $wp_current_screen_options;
- 
- 	if ( is_string($screen) )
- 		$screen = convert_to_screen($screen);
- 
- 	$columns = get_column_headers( $screen );
- 	$hidden = get_hidden_columns( $screen );
- 
- 	$meta_screens = array('index' => 'dashboard');
- 
- 	if ( isset($meta_screens[$screen->id]) ) {
- 		$screen->id = $meta_screens[$screen->id];
- 		$screen->base = $screen->id;
- 	}
- 
- 	$show_screen = false;
- 	if ( !empty($wp_meta_boxes[$screen->id]) || !empty($columns) )
- 		$show_screen = true;
- 
- 	$screen_options = screen_options($screen);
- 	if ( $screen_options )
- 		$show_screen = true;
- 
- 	if ( !isset($_wp_contextual_help) )
- 		$_wp_contextual_help = array();
- 
- 	$settings = apply_filters('screen_settings', '', $screen);
- 
- 	switch ( $screen->id ) {
- 		case 'widgets':
- 			$settings = '<p><a id="access-on" href="widgets.php?widgets-access=on">' . __('Enable accessibility mode') . '</a><a id="access-off" href="widgets.php?widgets-access=off">' . __('Disable accessibility mode') . "</a></p>\n";
- 			$show_screen = true;
- 			break;
- 	}
- 	if ( ! empty( $settings ) )
- 		$show_screen = true;
- 
- 	if ( !empty($wp_current_screen_options) )
- 		$show_screen = true;
- 
- 	$show_screen = apply_filters('screen_options_show_screen', $show_screen, $screen);
- 
- ?>
- <div id="screen-meta">
- <?php if ( $show_screen ) : ?>
- <div id="screen-options-wrap" class="hidden">
- 	<form id="adv-settings" action="" method="post">
- 	<?php if ( isset($wp_meta_boxes[$screen->id]) ) : ?>
- 		<h5><?php _ex('Show on screen', 'Metaboxes') ?></h5>
- 		<div class="metabox-prefs">
- 			<?php meta_box_prefs($screen); ?>
- 			<br class="clear" />
- 		</div>
- 		<?php endif;
- 		if ( ! empty($columns) ) : ?>
- 		<h5><?php echo ( isset( $columns['_title'] ) ?  $columns['_title'] :  _x('Show on screen', 'Columns') ) ?></h5>
- 		<div class="metabox-prefs">
- <?php
- 	$special = array('_title', 'cb', 'comment', 'media', 'name', 'title', 'username', 'blogname');
- 
- 	foreach ( $columns as $column => $title ) {
- 		// Can't hide these for they are special
- 		if ( in_array( $column, $special ) )
- 			continue;
- 		if ( empty( $title ) )
- 			continue;
- 
- 		if ( 'comments' == $column )
- 			$title = __( 'Comments' );
- 		$id = "$column-hide";
- 		echo '<label for="' . $id . '">';
- 		echo '<input class="hide-column-tog" name="' . $id . '" type="checkbox" id="' . $id . '" value="' . $column . '"' . checked( !in_array($column, $hidden), true, false ) . ' />';
- 		echo "$title</label>\n";
- 	}
- ?>
- 			<br class="clear" />
- 		</div>
- 	<?php endif;
- 	echo screen_layout($screen);
- 
- 	if ( !empty( $screen_options ) ) {
- 		?>
- 		<h5><?php _ex('Show on screen', 'Screen Options') ?></h5>
- 		<?php
- 	}
- 
- 	echo $screen_options;
- 	echo $settings; ?>
- <div><?php wp_nonce_field( 'screen-options-nonce', 'screenoptionnonce', false ); ?></div>
- </form>
- </div>
- 
- <?php endif; // $show_screen
- 
- 	$_wp_contextual_help = apply_filters('contextual_help_list', $_wp_contextual_help, $screen);
- 	?>
- 	<div id="contextual-help-wrap" class="hidden">
- 	<?php
- 	$contextual_help = '';
- 	if ( isset($_wp_contextual_help[$screen->id]) ) {
- 		$contextual_help .= '<div class="metabox-prefs">' . $_wp_contextual_help[$screen->id] . "</div>\n";
- 	} else {
- 		$contextual_help .= '<div class="metabox-prefs">';
- 		$default_help = __('<a href="http://codex.wordpress.org/" target="_blank">Documentation</a>');
- 		$default_help .= '<br />';
- 		$default_help .= __('<a href="http://wordpress.org/support/" target="_blank">Support Forums</a>');
- 		$contextual_help .= apply_filters('default_contextual_help', $default_help);
- 		$contextual_help .= "</div>\n";
- 	}
- 
- 	echo apply_filters('contextual_help', $contextual_help, $screen->id, $screen);
- 	?>
- 	</div>
- 
- <div id="screen-meta-links">
- <div id="contextual-help-link-wrap" class="hide-if-no-js screen-meta-toggle">
- <a href="#contextual-help" id="contextual-help-link" class="show-settings"><?php _e('Help') ?></a>
- </div>
- <?php if ( $show_screen ) { ?>
- <div id="screen-options-link-wrap" class="hide-if-no-js screen-meta-toggle">
- <a href="#screen-options" id="show-settings-link" class="show-settings"><?php _e('Screen Options') ?></a>
- </div>
- <?php } ?>
- </div>
- </div>
- <?php
- }
- 
- /**
-  * Add contextual help text for a page
-  *
-  * @since 2.7.0
-  *
-  * @param string $screen The handle for the screen to add help to.  This is usually the hook name returned by the add_*_page() functions.
-  * @param string $help Arbitrary help text
-  */
- function add_contextual_help($screen, $help) {
- 	global $_wp_contextual_help;
- 
- 	if ( is_string($screen) )
- 		$screen = convert_to_screen($screen);
- 
- 	if ( !isset($_wp_contextual_help) )
- 		$_wp_contextual_help = array();
- 
- 	$_wp_contextual_help[$screen->id] = $help;
- }
- 
- function screen_layout($screen) {
- 	global $screen_layout_columns, $wp_current_screen_options;
- 
- 	if ( is_string($screen) )
- 		$screen = convert_to_screen($screen);
- 
- 	// Back compat for plugins using the filter instead of add_screen_option()
- 	$columns = apply_filters('screen_layout_columns', array(), $screen->id, $screen);
- 	if ( !empty($columns) && isset($columns[$screen->id]) )
- 		add_screen_option('layout_columns', array('max' => $columns[$screen->id]) );
- 
- 	if ( !isset($wp_current_screen_options['layout_columns']) ) {
- 		$screen_layout_columns = 0;
- 		return '';
- 	}
- 
- 	$screen_layout_columns = get_user_option("screen_layout_$screen->id");
- 	$num = $wp_current_screen_options['layout_columns']['max'];
- 
- 	if ( ! $screen_layout_columns ) {
- 		if ( isset($wp_current_screen_options['layout_columns']['default']) )
- 			$screen_layout_columns = $wp_current_screen_options['layout_columns']['default'];
- 		else
- 			$screen_layout_columns = 2;
- 	}
- 
- 	$i = 1;
- 	$return = '<h5>' . __('Screen Layout') . "</h5>\n<div class='columns-prefs'>" . __('Number of Columns:') . "\n";
- 	while ( $i <= $num ) {
- 		$return .= "<label><input type='radio' name='screen_columns' value='$i'" . ( ($screen_layout_columns == $i) ? " checked='checked'" : "" ) . " /> $i</label>\n";
- 		++$i;
- 	}
- 	$return .= "</div>\n";
- 	return $return;
- }
- 
- /**
-  * Register and configure an admin screen option
-  *
-  * @since 3.1.0
-  *
-  * @param string $option An option name.
-  * @param mixed $args Option dependent arguments
-  * @return void
-  */
- function add_screen_option( $option, $args = array() ) {
- 	global $wp_current_screen_options;
- 
- 	if ( !isset($wp_current_screen_options) )
- 		$wp_current_screen_options = array();
- 
- 	$wp_current_screen_options[$option] = $args;
- }
- 
- function screen_options($screen) {
- 	global $wp_current_screen_options;
- 
- 	if ( is_string($screen) )
- 		$screen = convert_to_screen($screen);
- 
- 	if ( !isset($wp_current_screen_options['per_page']) )
- 		return '';
- 
- 	$per_page_label = $wp_current_screen_options['per_page']['label'];
- 
- 	if ( empty($wp_current_screen_options['per_page']['option']) ) {
- 		$option = str_replace( '-', '_', "{$screen->id}_per_page" );
- 	} else {
- 		$option = $wp_current_screen_options['per_page']['option'];
- 	}
- 
- 	$per_page = (int) get_user_option( $option );
- 	if ( empty( $per_page ) || $per_page < 1 ) {
- 		if ( isset($wp_current_screen_options['per_page']['default']) )
- 			$per_page = $wp_current_screen_options['per_page']['default'];
- 		else
- 			$per_page = 20;
- 	}
- 
- 	if ( 'edit_comments_per_page' == $option )
- 		$per_page = apply_filters( 'comments_per_page', $per_page, isset($_REQUEST['comment_status']) ? $_REQUEST['comment_status'] : 'all' );
- 	elseif ( 'categories_per_page' == $option )
- 		$per_page = apply_filters( 'edit_categories_per_page', $per_page );
- 	else
- 		$per_page = apply_filters( $option, $per_page );
- 
- 	// Back compat
- 	if ( isset( $screen->post_type ) )
- 		$per_page = apply_filters( 'edit_posts_per_page', $per_page, $screen->post_type );
- 
- 	$return = "<div class='screen-options'>\n";
- 	if ( !empty($per_page_label) )
- 		$return .= "<input type='text' class='screen-per-page' name='wp_screen_options[value]' id='$option' maxlength='3' value='$per_page' /> <label for='$option'>$per_page_label</label>\n";
- 	$return .= get_submit_button( __( 'Apply' ), 'button', 'screen-options-apply', false );
- 	$return .= "<input type='hidden' name='wp_screen_options[option]' value='" . esc_attr($option) . "' />";
- 	$return .= "</div>\n";
- 	return $return;
- }
- 
- function screen_icon( $screen = '' ) {
- 	echo get_screen_icon( $screen );
- }
- 
- function get_screen_icon( $screen = '' ) {
- 	global $current_screen, $typenow;
- 
- 	if ( empty($screen) )
- 		$screen = $current_screen;
- 	elseif ( is_string($screen) )
- 		$name = $screen;
- 
- 	$class = 'icon32';
- 
- 	if ( empty($name) ) {
- 		if ( !empty($screen->parent_base) )
- 			$name = $screen->parent_base;
- 		else
- 			$name = $screen->base;
- 
- 		if ( 'edit' == $name && isset($screen->post_type) && 'page' == $screen->post_type )
- 			$name = 'edit-pages';
- 
- 		$post_type = '';
- 		if ( isset( $screen->post_type ) )
- 			$post_type = $screen->post_type;
- 		elseif ( $current_screen == $screen )
- 			$post_type = $typenow;
- 		if ( $post_type )
- 			$class .= ' ' . sanitize_html_class( 'icon32-posts-' . $post_type );
- 	}
- 
- 	return '<div id="icon-' . esc_attr( $name ) . '" class="' . $class . '"><br /></div>';
- }
- 
- /**
   * Test support for compressing JavaScript from PHP
   *
   * Outputs JavaScript that tests if compression from PHP works as expected
--- 1508,1513 ----
***************
*** 2058,2155 ****
  }
  
  /**
-  *  Get the current screen object
-  *
-  *  @since 3.1.0
-  *
-  * @return object Current screen object
-  */
- function get_current_screen() {
- 	global $current_screen;
- 
- 	if ( !isset($current_screen) )
- 		return null;
- 
- 	return $current_screen;
- }
- 
- /**
-  * Set the current screen object
-  *
-  * @since 3.0.0
-  *
-  * @uses $current_screen
-  *
-  * @param string $id Screen id, optional.
-  */
- function set_current_screen( $id =  '' ) {
- 	global $current_screen, $hook_suffix, $typenow, $taxnow;
- 
- 	$action = '';
- 
- 	if ( empty($id) ) {
- 		$current_screen = $hook_suffix;
- 		$current_screen = str_replace('.php', '', $current_screen);
- 		if ( preg_match('/-add|-new$/', $current_screen) )
- 			$action = 'add';
- 		$current_screen = str_replace('-new', '', $current_screen);
- 		$current_screen = str_replace('-add', '', $current_screen);
- 		$current_screen = array('id' => $current_screen, 'base' => $current_screen);
- 	} else {
- 		$id = sanitize_key($id);
- 		if ( false !== strpos($id, '-') ) {
- 			list( $id, $typenow ) = explode('-', $id, 2);
- 			if ( taxonomy_exists( $typenow ) ) {
- 				$id = 'edit-tags';
- 				$taxnow = $typenow;
- 				$typenow = '';
- 			}
- 		}
- 		$current_screen = array('id' => $id, 'base' => $id);
- 	}
- 
- 	$current_screen = (object) $current_screen;
- 
- 	$current_screen->action = $action;
- 
- 	// Map index to dashboard
- 	if ( 'index' == $current_screen->base )
- 		$current_screen->base = 'dashboard';
- 	if ( 'index' == $current_screen->id )
- 		$current_screen->id = 'dashboard';
- 
- 	if ( 'edit' == $current_screen->id ) {
- 		if ( empty($typenow) )
- 			$typenow = 'post';
- 		$current_screen->id .= '-' . $typenow;
- 		$current_screen->post_type = $typenow;
- 	} elseif ( 'post' == $current_screen->id ) {
- 		if ( empty($typenow) )
- 			$typenow = 'post';
- 		$current_screen->id = $typenow;
- 		$current_screen->post_type = $typenow;
- 	} elseif ( 'edit-tags' == $current_screen->id ) {
- 		if ( empty($taxnow) )
- 			$taxnow = 'post_tag';
- 		$current_screen->id = 'edit-' . $taxnow;
- 		$current_screen->taxonomy = $taxnow;
- 	}
- 
- 	$current_screen->is_network = is_network_admin();
- 	$current_screen->is_user = is_user_admin();
- 
- 	if ( $current_screen->is_network ) {
- 		$current_screen->base .= '-network';
- 		$current_screen->id .= '-network';
- 	} elseif ( $current_screen->is_user ) {
- 		$current_screen->base .= '-user';
- 		$current_screen->id .= '-user';
- 	}
- 
- 	$current_screen = apply_filters('current_screen', $current_screen);
- }
- 
- /**
   * Echos a submit button, with provided text and appropriate class
   *
   * @since 3.1.0
--- 1573,1578 ----
***************
*** 2162,2168 ****
   * 			   false otherwise. Defaults to true
   * @param array|string $other_attributes Other attributes that should be output with the button,
   *                     mapping attributes to their values, such as array( 'tabindex' => '1' ).
!  *                     These attributes will be ouput as attribute="value", such as tabindex="1".
   *                     Defaults to no other attributes. Other attributes can also be provided as a
   *                     string such as 'tabindex="1"', though the array format is typically cleaner.
   */
--- 1585,1591 ----
   * 			   false otherwise. Defaults to true
   * @param array|string $other_attributes Other attributes that should be output with the button,
   *                     mapping attributes to their values, such as array( 'tabindex' => '1' ).
!  *                     These attributes will be output as attribute="value", such as tabindex="1".
   *                     Defaults to no other attributes. Other attributes can also be provided as a
   *                     string such as 'tabindex="1"', though the array format is typically cleaner.
   */
***************
*** 2183,2189 ****
   * 			   false otherwise. Defaults to true
   * @param array|string $other_attributes Other attributes that should be output with the button,
   *                     mapping attributes to their values, such as array( 'tabindex' => '1' ).
!  *                     These attributes will be ouput as attribute="value", such as tabindex="1".
   *                     Defaults to no other attributes. Other attributes can also be provided as a
   *                     string such as 'tabindex="1"', though the array format is typically cleaner.
   */
--- 1606,1612 ----
   * 			   false otherwise. Defaults to true
   * @param array|string $other_attributes Other attributes that should be output with the button,
   *                     mapping attributes to their values, such as array( 'tabindex' => '1' ).
!  *                     These attributes will be output as attribute="value", such as tabindex="1".
   *                     Defaults to no other attributes. Other attributes can also be provided as a
   *                     string such as 'tabindex="1"', though the array format is typically cleaner.
   */
***************
*** 2226,2228 ****
--- 1649,1834 ----
  
  	return $button;
  }
+ 
+ function _wp_admin_html_begin() {
+ ?>
+ <!DOCTYPE html>
+ <!--[if IE 8]>
+ <html xmlns="http://www.w3.org/1999/xhtml" class="ie8" <?php do_action('admin_xml_ns'); ?> <?php language_attributes(); ?>>
+ <![endif]-->
+ <!--[if !(IE 8) ]><!-->
+ <html xmlns="http://www.w3.org/1999/xhtml" <?php do_action('admin_xml_ns'); ?> <?php language_attributes(); ?>>
+ <!--<![endif]-->
+ <head>
+ <meta http-equiv="Content-Type" content="<?php bloginfo('html_type'); ?>; charset=<?php echo get_option('blog_charset'); ?>" />
+ <?php
+ }
+ 
+ final class WP_Internal_Pointers {
+ 	/**
+ 	 * Initializes the new feature pointers.
+ 	 *
+ 	 * @since 3.3.0
+ 	 *
+ 	 * All pointers can be disabled using the following:
+ 	 *     remove_action( 'admin_enqueue_scripts', array( 'WP_Internal_Pointers', 'enqueue_scripts' ) );
+ 	 *
+ 	 * Individual pointers (e.g. wp330_toolbar) can be disabled using the following:
+ 	 *     remove_action( 'admin_print_footer_scripts', array( 'WP_Internal_Pointers', 'pointer_wp330_toolbar' ) );
+ 	 */
+ 	public static function enqueue_scripts( $hook_suffix ) {
+ 		/*
+ 		 * Register feature pointers
+ 		 * Format: array( hook_suffix => pointer_id )
+ 		 */
+ 
+ 		$registered_pointers = array(
+ 			'index.php'    => 'wp330_toolbar',
+ 			'post-new.php' => 'wp330_media_uploader',
+ 			'post.php'     => 'wp330_media_uploader',
+ 			'themes.php'   => 'wp330_saving_widgets',
+ 		);
+ 
+ 		// Check if screen related pointer is registered
+ 		if ( empty( $registered_pointers[ $hook_suffix ] ) )
+ 			return;
+ 
+ 		$pointer = $registered_pointers[ $hook_suffix ];
+ 
+ 		$caps_required = array(
+ 			'wp330_media_uploader' => array( 'upload_files' ),
+ 			'wp330_saving_widgets' => array( 'edit_theme_options', 'switch_themes' ),
+ 		);
+ 
+ 		if ( isset( $caps_required[ $pointer ] ) ) {
+ 			foreach ( $caps_required[ $pointer ] as $cap ) {
+ 				if ( ! current_user_can( $cap ) )
+ 					return;
+ 			}
+ 		}
+ 
+ 		// Get dismissed pointers
+ 		$dismissed = explode( ',', (string) get_user_meta( get_current_user_id(), 'dismissed_wp_pointers', true ) );
+ 
+ 		// Pointer has been dismissed
+ 		if ( in_array( $pointer, $dismissed ) )
+ 			return;
+ 
+ 		// Bind pointer print function
+ 		add_action( 'admin_print_footer_scripts', array( 'WP_Internal_Pointers', 'pointer_' . $pointer ) );
+ 
+ 		// Add pointers script and style to queue
+ 		wp_enqueue_style( 'wp-pointer' );
+ 		wp_enqueue_script( 'wp-pointer' );
+ 	}
+ 
+ 	/**
+ 	 * Print the pointer javascript data.
+ 	 *
+ 	 * @since 3.3.0
+ 	 *
+ 	 * @param string $pointer_id The pointer ID.
+ 	 * @param string $selector The HTML elements, on which the pointer should be attached.
+ 	 * @param array  $args Arguments to be passed to the pointer JS (see wp-pointer.dev.js).
+ 	 */
+ 	private static function print_js( $pointer_id, $selector, $args ) {
+ 		if ( empty( $pointer_id ) || empty( $selector ) || empty( $args ) || empty( $args['content'] ) )
+ 			return;
+ 
+ 		?>
+ 		<script type="text/javascript">
+ 		//<![CDATA[
+ 		jQuery(document).ready( function($) {
+ 			var options = <?php echo json_encode( $args ); ?>;
+ 
+ 			if ( ! options )
+ 				return;
+ 
+ 			options = $.extend( options, {
+ 				close: function() {
+ 					$.post( ajaxurl, {
+ 						pointer: '<?php echo $pointer_id; ?>',
+ 						action: 'dismiss-wp-pointer'
+ 					});
+ 				}
+ 			});
+ 
+ 			$('<?php echo $selector; ?>').pointer( options ).pointer('open');
+ 		});
+ 		//]]>
+ 		</script>
+ 		<?php
+ 	}
+ 
+ 	public static function pointer_wp330_toolbar() {
+ 		$content  = '<h3>' . esc_js( __( 'New Feature: Toolbar' ) ). '</h3>';
+ 		$content .= '<p>' . esc_js( __( 'We&#8217;ve combined the admin bar and the old Dashboard header into one persistent toolbar. Hover over the toolbar items to see what&#8217;s new.' ) ) . '</p>';
+ 
+ 		if ( is_multisite() && is_super_admin() )
+ 			$content .= '<p>' .esc_js( __( 'Network Admin is now located in the My Sites menu.' ) ) . '</p>';
+ 
+ 		WP_Internal_Pointers::print_js( 'wp330_toolbar', '#wpadminbar', array(
+ 			'content'  => $content,
+ 			'position' => array( 'edge' => 'top', 'align' => 'center' ),
+ 		) );
+ 	}
+ 
+ 	/**
+ 	 * Print 'Updated Media Uploader' for 3.3.0.
+ 	 *
+ 	 * @since 3.3.0
+ 	 */
+ 	public static function pointer_wp330_media_uploader() {
+ 		$content  = '<h3>' . esc_js( __( 'Updated Media Uploader' ) ) . '</h3>';
+ 		$content .= '<p>' . esc_js( __( 'The single media icon now launches the uploader for all file types, and the new drag and drop interface makes uploading a breeze.' ) ) . '</p>';
+ 
+ 		WP_Internal_Pointers::print_js( 'wp330_media_uploader', '#content-add_media', array(
+ 			'content'  => $content,
+ 			'position' => array( 'edge' => is_rtl() ? 'right' : 'left', 'align' => 'center' ),
+ 		) );
+ 	}
+ 
+ 	/**
+ 	 * Print 'New Feature: Saving Widgets' for 3.3.0.
+ 	 *
+ 	 * @since 3.3.0
+ 	 */
+ 	public static function pointer_wp330_saving_widgets() {
+ 		$content  = '<h3>' . esc_js( __( 'New Feature: Saving Widgets' ) ) . '</h3>';
+ 		$content .= '<p>' . esc_js( __( 'If you change your mind and revert to your previous theme, we&#8217;ll put the widgets back the way you had them.' ) ) . '</p>';
+ 
+ 		WP_Internal_Pointers::print_js( 'wp330_saving_widgets', '#message2', array(
+ 			'content'  => $content,
+ 			'position' => array( 'edge' => 'top', 'align' => is_rtl() ? 'right' : 'left' ),
+ 		) );
+ 	}
+ 
+ 	/**
+ 	 * Prevents new users from seeing existing 'new feature' pointers.
+ 	 *
+ 	 * @since 3.3.0
+ 	 */
+ 	public static function dismiss_pointers_for_new_users( $user_id ) {
+ 		add_user_meta( $user_id, 'dismissed_wp_pointers', 'wp330_toolbar,wp330_media_uploader,wp330_saving_widgets' );
+ 	}
+ }
+ 
+ add_action( 'admin_enqueue_scripts', array( 'WP_Internal_Pointers', 'enqueue_scripts'                ) );
+ add_action( 'user_register',         array( 'WP_Internal_Pointers', 'dismiss_pointers_for_new_users' ) );
+ 
+ /**
+  * Convert a screen string to a screen object
+  *
+  * @since 3.0.0
+  *
+  * @param string $hook_name The hook name (also known as the hook suffix) used to determine the screen.
+  * @return WP_Screen Screen object.
+  */
+ function convert_to_screen( $hook_name ) {
+ 	if ( ! class_exists( 'WP_Screen' ) ) {
+ 		_doing_it_wrong( 'convert_to_screen(), add_meta_box()', __( "Likely direct inclusion of wp-admin/includes/template.php in order to use add_meta_box(). This is very wrong. Hook the add_meta_box() call into the add_meta_boxes action instead." ), '3.3' );
+ 		return (object) array( 'id' => '_invalid', 'base' => '_are_belong_to_us' );
+ 	}
+ 
+ 	return WP_Screen::get( $hook_name );
+ }
\ No newline at end of file
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-admin/includes/theme-install.php ./wordpress-3.3/wp-admin/includes/theme-install.php
*** ./wordpress-3.2.1/wp-admin/includes/theme-install.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-admin/includes/theme-install.php	2011-10-20 10:04:46.000000000 -0500
***************
*** 172,182 ****
  <?php endif; ?>
  <div class="star-holder" title="<?php printf(_n('(based on %s rating)', '(based on %s ratings)', $theme->num_ratings), number_format_i18n($theme->num_ratings)) ?>">
  	<div class="star star-rating" style="width: <?php echo esc_attr($theme->rating) ?>px"></div>
! 	<div class="star star5"><img src="<?php echo admin_url('images/star.png?v=20110615'); ?>" alt="<?php _e('5 stars') ?>" /></div>
! 	<div class="star star4"><img src="<?php echo admin_url('images/star.png?v=20110615'); ?>" alt="<?php _e('4 stars') ?>" /></div>
! 	<div class="star star3"><img src="<?php echo admin_url('images/star.png?v=20110615'); ?>" alt="<?php _e('3 stars') ?>" /></div>
! 	<div class="star star2"><img src="<?php echo admin_url('images/star.png?v=20110615'); ?>" alt="<?php _e('2 stars') ?>" /></div>
! 	<div class="star star1"><img src="<?php echo admin_url('images/star.png?v=20110615'); ?>" alt="<?php _e('1 star') ?>" /></div>
  </div>
  </div>
  <?php }
--- 172,182 ----
  <?php endif; ?>
  <div class="star-holder" title="<?php printf(_n('(based on %s rating)', '(based on %s ratings)', $theme->num_ratings), number_format_i18n($theme->num_ratings)) ?>">
  	<div class="star star-rating" style="width: <?php echo esc_attr($theme->rating) ?>px"></div>
! 	<div class="star star5"><img src="<?php echo admin_url('images/star.png?v=20110615'); ?>" alt="<?php esc_attr_e('5 stars') ?>" /></div>
! 	<div class="star star4"><img src="<?php echo admin_url('images/star.png?v=20110615'); ?>" alt="<?php esc_attr_e('4 stars') ?>" /></div>
! 	<div class="star star3"><img src="<?php echo admin_url('images/star.png?v=20110615'); ?>" alt="<?php esc_attr_e('3 stars') ?>" /></div>
! 	<div class="star star2"><img src="<?php echo admin_url('images/star.png?v=20110615'); ?>" alt="<?php esc_attr_e('2 stars') ?>" /></div>
! 	<div class="star star1"><img src="<?php echo admin_url('images/star.png?v=20110615'); ?>" alt="<?php esc_attr_e('1 star') ?>" /></div>
  </div>
  </div>
  <?php }
***************
*** 237,243 ****
  	iframe_header( __('Theme Install') );
  
  	if ( empty($api->download_link) ) {
! 		echo '<div id="message" class="error"><p>' . __('<strong>Error:</strong> This theme is currently not available. Please try again later.') . '</p></div>';
  		iframe_footer();
  		exit;
  	}
--- 237,243 ----
  	iframe_header( __('Theme Install') );
  
  	if ( empty($api->download_link) ) {
! 		echo '<div id="message" class="error"><p>' . __('<strong>ERROR:</strong> This theme is currently not available. Please try again later.') . '</p></div>';
  		iframe_footer();
  		exit;
  	}
***************
*** 262,268 ****
  	}
  
  	$themes = get_themes();
! 	foreach ( $themes as $this_theme ) {
  		if ( is_array($this_theme) && $this_theme['Stylesheet'] == $api->slug ) {
  			if ( $this_theme['Version'] == $api->version ) {
  				$type = 'latest_installed';
--- 262,268 ----
  	}
  
  	$themes = get_themes();
! 	foreach ( (array) $themes as $this_theme ) {
  		if ( is_array($this_theme) && $this_theme['Stylesheet'] == $api->slug ) {
  			if ( $this_theme['Version'] == $api->version ) {
  				$type = 'latest_installed';
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-admin/includes/theme.php ./wordpress-3.3/wp-admin/includes/theme.php
*** ./wordpress-3.2.1/wp-admin/includes/theme.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-admin/includes/theme.php	2011-11-11 08:10:54.000000000 -0600
***************
*** 16,25 ****
--- 16,34 ----
  function current_theme_info() {
  	$themes = get_themes();
  	$current_theme = get_current_theme();
+ 
+ 	if ( ! $themes ) {
+ 		$ct = new stdClass;
+ 		$ct->name = $current_theme;
+ 		return $ct;
+ 	}
+ 
  	if ( ! isset( $themes[$current_theme] ) ) {
  		delete_option( 'current_theme' );
  		$current_theme = get_current_theme();
  	}
+ 
+ 	$ct = new stdClass;
  	$ct->name = $current_theme;
  	$ct->title = $themes[$current_theme]['Title'];
  	$ct->version = $themes[$current_theme]['Version'];
